# DO NOT EDIT: Autogenerated by src/docker_composer/_utils/generate_class.py
# for docker-compose version 1.25.0, build unknown

from typing import List, Optional

import attr

from docker_composer.base import DockerBaseRunner


@attr.s(auto_attribs=True)
class DockerComposeDown(DockerBaseRunner):
    """
    Stops containers and removes containers, networks, volumes, and images
    created by `up`.

    By default, the only things removed are:

    - Containers for services defined in the Compose file
    - Networks defined in the `networks` section of the Compose file
    - The default network, if one is used

    Networks and volumes defined as `external` are never removed.

    Usage: down [options]

    """

    rmi: Optional[str] = None
    """Remove images. Type must be one of:
       'all': Remove all images used by any service.
       'local': Remove only images that don't have a
       custom tag set by the `image` field."""
    volumes: Optional[bool] = None
    """Remove named volumes declared in the `volumes`
       section of the Compose file and anonymous volumes
       attached to containers."""
    remove_orphans: Optional[bool] = None
    """Remove containers for services not defined in the
       Compose file"""
    timeout: Optional[int] = None
    """Specify a shutdown timeout in seconds.
       (default: 10)"""
    _cmd: str = "down"
    _options: List[str] = [
        "volumes",
        "remove_orphans",
    ]
